; OKCHAR.ASM - this performs all character handling routines.
; since some screens have no bios character routines in graphics
; mode it is necessary to write our own
;
; PUBLIC ROUTINES ARE:
;
;  do_char - prints a character at curx,xry
;  print_string - prints the string starting at curx,cury
;
dseg        SEGMENT PUBLIC 'DATA'
            ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN       attribute:BYTE,font:WORD,curx:WORD,cury:WORD,interlace:WORD
EXTRN       vid_wid:WORD,vbuffer:WORD,left_margin:word,blop:near
extrn       comsi:word
      extrn save_font:word
;
; local variables
;
lscale dw  1
public lscale
lcount dw  0
cwidth dw  0
public cwidth
fontbuff  db 300 dup(0)
public fontbuff
;
dseg        ENDS
tseg   segment public 'DATA'
db 0
;
tseg   ends
lseg        SEGMENT PUBLIC 'DATA'
       ASSUME DS:lseg,ES:lseg
      extrn font0:byte
      extrn font1:byte
      extrn font2:byte
      extrn logo:byte
      font3 equ byte ptr logo
      font4 equ byte ptr logo+3585
lseg        ENDS
cseg        SEGMENT PUBLIC 'CODE'
            ASSUME CS:cseg,DS:dseg,ES:dseg
PUBLIC      do_char,print_string,tprint_string
extrn reset_segs:near,do_col_char2:near
charget:
; this gets a character from the current font and puts into
; charbuff so it can be worked on
public  charget
;
; al has the character to get
       push   ax
       push   bx
       push   cx
       push   dx
       push   si
       push   di
       push   ds
       push   es
       call   reset_segs
;
       mov    bl,al    ; al has the character to print
       mov    bh,0
       mov    ax,lseg
       mov    ds,ax
       MOV    si,es:font     ; get current font offset
       lea    di,fontbuff
       mov    cl,byte ptr ds:[si]
       inc   si
       mov  ch,0
       mov   es:cwidth,cx   ; anyone can use it
       mov  ax,bx
       mul  cx
       add  si,ax   ; offset into font
       cld
rep    movsb        ; move char into fontbuff
       pop    es
       pop    ds
       pop    di
       pop    si
       pop    dx
       pop    cx
       pop    bx
       pop    ax
       ret

assume cs:cseg,ds:dseg,es:dseg
fontset:
do_font0:
public do_font0
     assume ds:lseg
      lea   ax,font0
     assume ds:dseg
      mov   font,ax
      mov   save_font,ax
      ret
do_font1:
public do_font1
     assume ds:lseg
      lea   ax,font1
     assume ds:dseg
      mov   font,ax
      mov   save_font,ax
      ret
do_font2:
public do_font2
     assume ds:lseg
      lea   ax,font2
     assume ds:dseg
      mov   font,ax
      mov   save_font,ax
      ret
do_font3:
public do_font3
      push   es
       mov    ax,lseg
       mov    es,ax
     assume es:lseg
      cmp   es:font3,0
     assume es:dseg
       pop   es
      je    no_font
     assume ds:lseg
      lea   ax,font3
     assume ds:dseg
      mov   font,ax
      mov   save_font,ax
      ret
no_font:
      call  blop
      call  blop
      call  blop
      stc
      ret
do_font4:
public do_font4
      push   es
       mov    ax,lseg
       mov    es,ax
     assume es:lseg
      cmp   es:font4,0
     assume es:dseg
       pop   es
      je    no_font
     assume ds:lseg
      lea   ax,font4
     assume ds:dseg
      mov   font,ax
      mov   save_font,ax
      ret
            ASSUME CS:cseg,DS:dseg,ES:dseg
;
tprint_string:
; tprint string prints a string pointed to by tseg:dx
       push  bp
       push  ds
       push  es
       call  reset_segs
       mov   bp,'KG'
       and   curx,1111111111111000b
       call  print_string2
;
       pop   es
       pop   ds
       pop   bp
       ret

print_string:
; on entry dx points to the string to print
       and   curx,1111111111111000b
            mov   al,attribute
            push  ax
            mov   attribute,0
            mov   bp,0
            jmp   tp_1
print_string2:
       and   curx,1111111111111000b
            mov   al,attribute
            push  ax
            mov   attribute,0
tp_1:
            MOV   SI,DX
ps_loop:
            CLD
            push   ds
            cmp    bp,'KG'
            jne    no_t
            mov    ax,tseg
            mov    ds,ax
no_t:
            LODSB
            pop   ds
            CMP   AL,0
            JE    end_p
            CMP   AL,13
            JNE   no13
            mov   ax,left_margin
            MOV   curx,ax
            JMP   ps_loop
no13:
            CMP   AL,10
            JNE   no10
            mov   ax,cwidth
            ADD   cury,ax
            JMP   ps_loop
no10:
            CMP   AL,'~'
            JNE   no_tilde
            mov   cx,27
ti_loop:
            push  cx
            PUSH  SI
            mov   al,20h
            CALL  do_col_char2
            POP   SI
            ADD   curx,8      ; character width
            pop   cx
            loop  ti_loop
            mov   al,20h
no_tilde:
            PUSH  SI
            CALL  do_col_char2
            POP   SI
            ADD   curx,8      ; character width
            JMP   ps_loop
end_p:
            pop   ax
            mov   attribute,al
            RET

do_char:
; do_char prints a letter to the screen. The current cursor
; is specified by curx and cury and is in absolute pels
; Pels must be converted to a real location on screen
; the char to print is in al
            push  ax
            push  bx
            push  cx
            push  dx
            push  bp
            push  si
            push  di
            push  ds
            push  es
            call reset_segs
;           cmp   comsi,0
;           je    cont_char1
;           jmp   leave_char
cont_char1:
            call  charget
            MOV   ES,vbuffer
            mov   cx,cwidth
            push  cx
            LEA   SI,fontbuff
            mov   lcount,0
; si points to the font area which we will be using
; calcualte next where it goes
;
; curx and cury are relative cursor locations on screen in pels
; this must be converted to rastor and byte locations
; first the x direction (from upper left corner)
;
            MOV   AX,curx
            MOV   DX,AX
            AND   DX,07
            MOV   CL,3
            SHR   AX,CL
; dx has the remainder pels, ax has the bytes across
; save this in di,bp
            MOV   DI,AX
            MOV   BP,DX
; now calculate rasters
            MOV   DX,0
            MOV   AX,DS:cury
            DIV   DS:interlace ;number of interlaced lines
            MOV   CX,DX
            MUL   DS:vid_wid  ;number of bytes per line
            MOV   DX,CX
; ax has the byte offset of beginning of line
; dx has the interlaced line number
            ADD   DI,AX       ; di has the byte to start at
;
; di has the byte offset of where the letter goes
; bp has the points, dx the interlace factor
            POP   CX    ; length of char from above
            cmp   lscale,0
            jne   no_scale_0
            shr   cx,1
no_scale_0:
            cmp   lscale,1
            jle   char_loop0
            shl   cx,1
            cmp   lscale,2
            je    char_loop0
            shl   cx,1
char_loop0:  ; this is for each of the line of the char
            PUSH  CX    ; save length
            CLD
            LODSB
; have an element in al, check for scale
            cmp   lscale,1
            je    no_scale
            cmp   lscale,0
            jne    no_zero_scale
            mov   ah,al
            lodsb
            or    al,ah
            jmp   no_scale
no_zero_scale:
            inc   lcount
            cmp   lscale,2
            jne   no_scale_2
            dec   si
            cmp   lcount,1
            je    no_scale
            mov   lcount,0
            inc   si
            jmp   no_scale
no_scale_2:
            dec   si
            cmp   lcount,4
            jl    no_scale
            mov   lcount,0
            inc   si
            jmp   no_scale
no_scale:
            MOV   CX,BP       ; bp has the bit offset for the character
            MOV   BX,0ff00h
            MOV   AH,0
            CMP   CX,0
            JE    by_char_loop1
            MOV   BX,0ffh
; this is the loop for moving the bits right
;
char_loop1:
            SHR   BL,1
            OR    BL,10000000b
            SHR   BH,1
            CLC
            RCR   AL,1
            RCR   AH,1
            LOOP  char_loop1
;
;
by_char_loop1:
            PUSH  BP    ; save bp til after loop
            MOV   BP,BX
            MOV   BX,0
            CMP   DX,0
            JLE   l20
            CMP   DX,1
            JE    l21
            CMP   DX,2
            JE    l22
l23:
            ADD   BH,20h
l22:
            ADD   BH,20h
l21:
            ADD   BH,20h
l20:
            cmp   attribute,-1
            je    xor_only
            cmp   attribute,-2
            je    put_only
; we have to decide whether or not its black on white or revers
            TEST  attribute,1 ; is the one bit on in attribute
            JZ    no_reverse
; we have to make ax a negative letter
            XOR   AX,0ffffh
no_reverse:
;  here decide if we should punch a hole or go direct to screen
            CMP   attribute,1
            JG    no_punch ;only 0 and 1 are punched to screen
; at this point bp has the mask which is anded to screen
; to punch a hole for the letter,
            AND   ES:[DI+BX],BP
no_punch:
;  check now to see if we can OR, AND or XOR to screen
; 0,1,2,3 are or
            CMP   attribute,3
            JG    not_or
            OR    ES:[DI+BX],AX
            JMP   by_char_loop1a
not_or:
            CMP   attribute,5
            JG    do_xor
            xor   bp,0ffffh
            and   ax,bp
            AND   ES:[DI+BX],AX
            JMP   by_char_loop1a
do_xor:
            xor   bp,0ffffh
            and   ax,bp
            push  cx
            mov   cx,ax
            mov   ax,ES:[DI+BX]
            xor   ax,cx
            mov   ES:[DI+BX],AX
            pop   cx
      jmp   by_char_loop1a
xor_only:
            push  cx
            mov   cx,ax
            mov   al,byte ptr ES:[DI+BX]
            xor   al,cl
            mov   byte ptr ES:[DI+BX],Al
            pop   cx
      jmp   by_char_loop1a
put_only:
            mov   byte ptr ES:[DI+BX],Al
;     jmp   by_char_loop1a
by_char_loop1a:
            MOV   BX,BP
            POP   BP
            INC   DX
            CMP   interlace,1
            JE    inc_char_line
            CMP   interlace,2
            JE    check_int_2
            CMP   DX,4
            JGE   inc_char_line
            JMP   end_char_loop2
check_int_2:
            CMP   DX,2
            JGE   inc_char_line
            JMP   end_char_loop2
inc_char_line:
            MOV   DX,0
            ADD   DI,vid_wid
end_char_loop2:
            POP   CX
            LOOP  char_loop2_x
leave_char:
            pop   es
            pop   ds
            pop   di
            pop   si
            pop   bp
            pop   dx
            pop   cx
            pop   bx
           pop    ax
            RET
char_loop2_x:
            JMP   char_loop0

cseg    ends
        end
