; OKFINGER.ASM is the finger display routines.
; this is totally different from PCRGB in that the finger
; is rotated as it is xored to the screen and that there
; are 4 different fingers, one for each quadrant.
;
; the public procedures are INIT_FINGER which initializes
; the 4 fingers (I ain't gonna type in all them bits)
; PUT_FINGER puts a finger into FX and FY, if the screen
; is clean (present has been issued), the finger is done
; twice, once in the old, once in the new.
;
DSEG segment public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn finger0:byte,finger1:byte,finger2:byte,finger3:byte
extrn fx:word,fy:word,clean:byte,vbuffer:word,vid_wid:word
extrn interlace:word,planes:word
extrn cline:word,mode:byte,egavga:byte

;  local data
;
cfx     dw  0    ; where the finger is going this time
cfy     dw  0
old_fx  dw  0    ; last x and y
old_fy  dw  0
fingerline dw finger0,finger1,finger2,finger3

DSEG ends


CSEG segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn  reset_segs:near,calc_bank:near
extrn  cmode:word

fixplane1:
public fixplane1
public fixplane2
; if the planes are more than 1 then its time to select a single
; plane
     push  ax
     push  dx
     push  ds
     push  es
     call  reset_segs
     cmp egavga,1
     jne no_plane1
; select a middle plane
        mov     dx,3c4h
        mov     al,2    ; map mask
        out     dx,al
        inc     dx
        mov     al,2    ; bit plane 3
        out     dx,al
; now set the read guy up ok?
        mov     dx,3ceh
        mov     al,4    ; map mask
        out     dx,al
        inc     dx
        mov     al,1    ; bit plane 3
        out     dx,al
no_plane1:
     pop  es
     pop  ds
     pop  dx
     pop  ax
     ret
fixplane2:
; if the planes are more than 1 then its time to select a single
; plane
     push  ax
     push  dx
     push  ds
     push  es
     call  reset_segs
     cmp egavga,1
     jne no_plane2

        mov     dx,3ceh
        mov     al,4    ; map mask
        out     dx,al
        inc     dx
        mov     al,0     ; bit plane 3
        out     dx,al
         mov     ax,0ff08h ; bit mask index and all bits
         mov     dx,3ceh
         out     dx,ax   ; set bit mask so all bits are on
        mov     dx,3c4h
        mov     al,2    ; map mask
        out     dx,al
        inc     dx
        mov     al,15   ; bit plane 3
        out     dx,al
no_plane2:
     pop  es
     pop  ds
     pop  dx
     pop  ax
     ret

put_finger  proc near
public put_finger
; set up finger stuff
       push  ax
       push  bx
       push  cx
       push  dx
       push  si
       push  di
       push  bp
       push  ds
       push  es
       call  reset_segs
       mov   al,mode
       mov   ah,0
       mov   cs:cmode,ax
;
;   we are here to xor a finger to the screen, the location is
; in fx,fy
; first to check and see if we have an old finger to xor
       cmp   clean,0
       je    clean_finger  ; no xor the old
       mov   ax,old_fx
       mov   cfx,ax
       mov   ax,old_fy
       mov   cfy,ax
       mov   cline,ax
       call  finger   ; undo it
clean_finger:
       mov   clean,1
       mov   ax,fx
       mov   cfx,ax
       mov   old_fx,ax
       mov   ax,fy
       mov   cfy,ax
       mov   old_fy,ax
       call  finger  ; do it!
exit_put_finger:
       pop   es
       pop   ds
       pop   bp
       pop   di
       pop   si
       pop   dx
       pop   cx
       pop   bx
       pop   ax
       clc
       ret
xorx macro
     push  ax
      mov  al,es:[di]
      xor  ah,al
      mov  es:[di],ah
     pop   ax
     endm

finger:
; this routine actually xor's a finger into the screen
;
;
;     call  fixplane1
; caclulate stuff where finger goes
; calculate which finger to use
; cfx,cfy has the place where it is going, based on a 80 byte screen
; CGA the top half is anything less than 100 is top half
; anything less than 320 is left
; a finger is 4*24 = 96 bytes
            lea  si,finger0
            cmp  cfy,100
            jl   finger01  ; must be finger 0 or 1
            add  si,192    ; go in two fingers
            sub  cfy,24    ; back off length of finger
finger01:
            cmp  cfx,320
            jl   finger_left
            add  si,96
            sub  cfx,32   ; back off width of finger
finger_left:
; si is good, now calc di - first the column adder
       mov   ax,cfy
       mov   cline,ax
            mov  ax,cfx
            mov  dx,0
            mov  cx,8
            div  cx
;  dx has the bits left over, ax has the amount to add to di
            mov  di,ax    ; start di
            mov  bp,dx    ; save bits
            mov  ax,cfy
            mov  dx,0
            div  interlace
            push dx   ; save the line number
            mul  vid_wid
            add  di,ax
             pop  ax  ; ax has the line number
; done with di
            mov  dx,vbuffer
            mov  bx,vid_wid
; here      dx has the vbuffer
;           di has the di offset into the screen
;           bp has a bit offset for rotating the finger
;           si has the offset of the finger
;           bx has the vid_wid
;
;
;  loop for xoring the 4 bytes
      push  ax
      push  dx
      mov   dx,0
      mov   ax,24
      div   interlace
      pop   dx
      mov   cx,ax     ; cx has how many times we pass this way
      pop   ax        ; ax has the line number to start with
      push  ax        ; save it for later
x_loop0:
      push  cx
; the next loop is the interlace loop
      mov   cx,interlace
      push  dx
      cmp  ax,0  ; line number
      je   next_loop
      sub  cx,ax
      push cx
      mov  cx,ax
z_loop:
      add  dx,200h
      loop z_loop
      pop  cx
next_loop:
      call  x_loop1
;  bottom loop end
;
      pop   dx
      add   di,bx
      pop   cx
      mov   ax,0
      loop  x_loop0
; here we have to check and see if there are any lines left to xor
      pop   cx    ; the lines from above (push ax)
      cmp   cx,0
      jne   xor_last
;     call  fixplane2
      ret
xor_last:
; do the interlace loop thing
      call  x_loop1
      call  fixplane2
      ret
; this is the routine that does the xoring
x_loop1:
      push  cx
      push di
      push dx
      mov  cx,bp
      mov   es,dx
; core, this xor's the finger to the screen
;
      call  setup_vesa
      mov  ax,0
; do this 4 times (easier than looping)
; pass 1
      mov  ah,ds:[si]
      inc  si
      shr  ax,cl
      xorx  es:[di],ah
      inc  di
; pass 2
      mov  dl,al
      mov  al,0
      mov  ah,ds:[si]
      inc  si
      shr  ax,cl
      or   ah,dl
      xorx  es:[di],ah
      inc  di
; pass 3
      mov  dl,al
      mov  al,0
      mov  ah,ds:[si]
      inc  si
      shr  ax,cl
      or   ah,dl
      xorx  es:[di],ah
      inc  di
; pass 4
      mov  dl,al
      mov  al,0
      mov  ah,ds:[si]
      inc  si
      shr  ax,cl
      or   ah,dl
      xorx  es:[di],ah
      push  ax
      mov  ah,es:[di+1]
      xor  al,ah
      mov  es:[di+1],al
      pop  ax
      pop  dx
; core ends here
      pop  di
; end of finger xor,
;
; end o interlace loop
      add   dx,200h
      pop   cx
      loop  x_loop1
      ret
setup_vesa:
            cmp  mode,-1
            jne  not_vesa1
            push  ax
            push  cx
            push  dx
            mov  ax,cfx
            mov  dx,0
            mov  cx,8
            div  cx
            call  calc_bank
            add   di,ax
            pop   dx
            pop   cx
            pop   ax
not_vesa1:
            ret
put_finger  endp

INIT_FINGER proc near
public init_finger
; basically what is going on here is we are mirror imaging
; the finger and then flipping the original and the mirror
; so that they will appear as 4 separate fingers, one for
; each of the quadrants. I could have done artwork in DATAG
; for these, but this is easier and nifty, too.
       call reset_segs
       mov  clean,0
       mov  fx,128
       mov  fy,80
       mov  old_fx,128
       mov  old_fy,80
; time to initialize finger1
       lea  si,finger0
       lea  di,finger1+3
       mov  cx,24
fi_loop0:
       push  cx
       mov  cx,4
fi_loop1:
       mov  al,ds:[si]
       mov  ah,0
       push cx
       mov  cx,8
       clc
fi_loop2:
       rcl  al,1
       rcr  ah,1
       loop fi_loop2
       mov  ds:[di],ah
       inc  si
       dec  di
       pop  cx
       loop fi_loop1
       add  di,8
       pop  cx
       loop fi_loop0
; now 2 gets the benfits of our work
       lea  si,finger0
       lea  di,finger2[23*4] ; last line of finger2
       mov  cx,24
f2_loop:
       push cx
       cld
       mov  cx,4
rep    movsb
       pop  cx
       sub  di,8  ; back off a line
       loop  f2_loop
; and now its finger3 time
;
       lea  si,finger1
       lea  di,finger3[23*4] ; last line of finger2
       mov  cx,24
f3_loop:
       push cx
       cld
       mov  cx,4
rep    movsb
       pop  cx
       sub  di,8  ; back off a line
       loop  f3_loop
; hey thats it! we are fingered
;
        ret
init_finger  endp

cseg  ends
      end
