;
; OKITREE.ASM is a menu for selection of image options
; we will try to write this so that the option will work for
; all selections too big for a tree
;
tseg segment public 'DATA'
assume  ds:tseg
tseg  ends
;
rows = 9
columns = 4
messwidth = 14
colwidth = messwidth*columns
DSEG segment public 'DATA'
  assume ds:dseg
extrn     left_margin:word,buffer:word,str_len:word
extrn     cdir:byte,cwidth:word
EXTRN     strg:BYTE,curx:word,cury:word
tbox  db '                                      ',10
      db '  Select a Function and Press Enter ',10
      db '        Press Esc to exit',0
cmess db ' COLOR FILL PATTERN ',0
imess db '  IMAGE ALTERATION  ',0
vmess db 'VIDEO CARD SELECTION',0
extrn  fbox:byte
fcount dw 0   ; cound of files on list
ldone  dw 0
lsave  dw 0
lmerge dw 0
linfo  dw 0
c_col dw 0
c_row dw 0
o_col dw 0
o_row dw 0
mousex db 0
space12  dw  6 dup(20h)
gline   db 1,1ch,47h,48h,49h,4bh,4dh,4fh,50h,51h
cfunc  dw 0
savesi  dw 0
limage  dw 0
who     db 0
;
;
DSEG ends
;
CSEG segment public 'CODE'
assume cs:cseg,ds:dseg,es:dseg

extrn  gstring:near,highlight:near
extrn present:near
extrn getkey:near,printline:near,reset_segs:near,print_string:near
extrn goback:near,exit_prog:near,prbox:near
extrn imline:word  ; cs list of functions for image
extrn viline:word  ; cs list of functions for video
extrn coline:word  ; list in datat3
extrn check_font:near,tprintline:near
extrn flush_mouse:near
;
do_vids:
public do_vids
    mov  who,'v'
    call check_font
    lea  si,vmess
    jmp  di1
;
do_colors:
   public do_colors
    mov  who,'c'
    call check_font
    lea  si,cmess
    jmp  di1
;
do_image:
   public do_image
    mov  who,'i'
    call check_font
    lea  si,imess
di1:
    lea  di,tbox+10
    call ms0
    mov  ax,limage
    mov  ldone,ax
    lea  si,imline   ; this is the image functions in datat3
    cmp  who,'i'
    je   di2
    lea  si,viline   ; also in data3
    cmp  who,'v'
    je   di2
    lea  si,coline   ; also in data3
di2:
    call do_info
    mov  bx,ldone
    mov  limage,bx
    cmp  al,27
    jne  do_image
    ret
; other options here
do_info:
    mov  savesi,si    ; save the line location
top_menu:
    call fillb
    mov  ax,ldone
    mov  cfunc,ax
    call get_a_func   ; scroll through until enter or esc
    cmp  al,27
    jne  rs1
    call  present
    mov  al,27
    ret
rs1:
;
    mov   bx,cfunc
    mov   ldone,bx
    shl   bx,1
    shl   bx,1
    add   bx,savesi
    call  word ptr cs:[bx]
    ret
;
;
;
;
;
get_a_func:
; files are now on screen, we have to have a loop to highlight
; the files
;
; dx has the current guy in it
    mov    ax,cfunc
    mov    dx,0
    mov    cx,rows
    div    cx
    mov    c_col,ax  ; current column
    mov    c_row,dx  ; current row
    mov    o_col,ax  ; old column
    mov    o_row,dx  ; old row
;
    call   top_line
    mov    bp,0
sel_loop:
    call   high_guy
    call   flush_mouse
;
gk1:
    call getkey
    cmp    dx,300h
    je     gk1
    cmp    al,27
    je     leave_selx
    cmp    al,13
    je     leave_selx
    xchg   al,ah
    lea    di,gline
    mov    cx,10
    cld
repne  scasb
    je     gk9
; a letter was pressed
    xchg   al,ah
    cmp    al,'z'
    jg     gk1
    cmp    al,'Z'
    jle    gk2
    sub    al,32
gk2:
    cmp    al,'A'
    jl     gk9
; have an A to Z letter
    mov   mousex,0
    mov    dl,al
    mov    ax,cfunc
    mov    bp,ax
; search for a match
gk3:
   inc    ax
   cmp    ax,bp
   je     gk1
   cmp    ax,fcount
   jl     gk4
   mov    ax,0
gk4:
   mov    bx,ax
   shl    bx,1
   shl    bx,1
   add    bx,savesi
   mov    si,word ptr cs:[bx+2]
   mov    bx,tseg
   push   ds
   mov    ds,bx
   cmp    dl,byte ptr ds:[si]
   pop    ds
   jne    gk3
; got it
   mov    cfunc,ax
   mov    cx,rows
   mov    dx,0
   div    cx
   mov    c_col,ax
   mov    c_row,dx
   call   check_c
   jmp    gk10
leave_selx: jmp leave_sel
gk9:
; check for mouse activity
    cmp   bp,'KG'  ; mouse active
    jne   gk9a
    inc   mousex
    cmp   mousex,20
    jge   gk9a
   jmp    gk1
gk9a:
    mov   mousex,0
; mov cursor keys here
    dec    di
    sub    di,offset gline
    shl    di,1
    push   bp
    call   word ptr cs:gtab[di]
    pop    bp
gk10:
    push  bp
    call   un_high_guy
    pop   bp
    jmp    sel_loop
leave_sel:
    ret
key_esc:
    call present
    ret
key_ret:
   ret
key_home:
   mov   c_col,0
   mov   c_row,0
   jmp   check_c
key_up:
   dec  c_row
   jmp   check_c
key_pup:
   mov   c_row,0
   jmp   check_c
key_left:
   dec   c_col
   jmp   check_c
key_right:
   inc   c_col
   jmp   check_c
key_end:
   mov   c_col,columns-1
   mov   c_row,rows-1
   jmp   check_c
key_dn:
   inc  c_row
   jmp   check_c
key_pdn:
   mov   c_row,13
;  jmp   check_c
check_c:
   cmp   c_row,0
   jge   dx_nl
   mov   c_row,rows-1
   dec   c_col
dx_nl:
   cmp   c_row,rows-1
   jle   dx_nh
   mov   c_row,0
   inc   c_col
dx_nh:
   cmp  c_col,columns-1
   jle  dx_hok
   mov  c_col,0
dx_hok:
   cmp  c_col,0
   jge  dx_lok
   mov  c_col,columns-1
dx_lok:
; now calculate cfunc and see if its ok
   mov  ax,c_col
   mov  cx,rows
   mul  cx
   add  ax,c_row
   mov  cfunc,ax
; see if we overran
   cmp  fcount,ax
   jg   ok_fcount
   dec  c_row
   jmp  check_c
;
;
top_line:
;
; this prints the line found in tseg,
   mov   ax,cfunc
ok_fcount:
; now locate and print the line.
; ax still has cfunc in it
    shl  ax,1
    shl  ax,1
    mov  bx,ax
    add  bx,savesi
    mov  si,word ptr cs:[bx+2]
    add  si,10   ; get bthe bar line
; this prints the description line
;
; have to calculate line 5
    mov   ax,5
    mul   cwidth
    mov  cury,ax
    mov  curx,48
    mov  cx,74
    call  tprintline
    ret
gtab  dw   key_esc,key_ret,key_home,key_up,key_pup,key_left
      dw   key_right,key_end,key_dn,key_pdn
un_high_guy:
    mov   ax,c_row
    push  ax
    mov   ax,c_col
    push  ax
    mov   ax,o_col
    mov   c_col,ax
    mov   ax,o_row
    mov   c_row,ax
    call  high_guy
    pop   ax
    mov   c_col,ax
    pop   ax
    mov   c_row,ax
    ret
high_guy:
; highlight the current selection
; this has cx for length to highlight
; curx and cury have the current location
     mov   ax,6
     mul   cwidth
     mov   cury,ax
     mov   ax,c_row
     mov   o_row,ax
     inc   ax
     mul   cwidth
     add   cury,ax
     mov   ax,c_col
     mov   o_col,ax
     mov   cx,112
     mul   cx
     add   ax,64
     mov   curx,ax
     mov   cx,13
     call  highlight
     ret
;
; fillb fills up the functions table with things from the op line
;
fillb:
; the cseg line comes in from the clling program
;
; si points to a line in cseg, the line has:
;   dw procedure to perform and
;   dw pointer to a tseg line of information

; strategy,
;   1. space out the box
;   2. move through the lines moving in descriptions
;
;
; move spaces to the box
    call  reset_segs
    lea   di,fbox
    mov   cx,rows
space_loop:
    push   cx
    mov    cx,colwidth
    mov    al,20h
rep  stosb
    mov    al,10
    stosb
    pop   cx
    loop  space_loop
    dec   di
    mov   al,0
    stosb
;
; done moving spaces into the box, now fill up box with the descriptions
; si is still safe
;
;
; files up fbox and fline
    mov  fcount,0     ; how many
    cld
fb0:
    push   si
    mov   bx,word ptr cs:[si]
    cmp   bx,-1  ; end of line is -1
    je    fb_end
fb8:
    inc  fcount
; now move the description into the box
    mov   ax,word ptr cs:[si+2]
    mov   si,ax
; si points to tseg description
;
; calculate where is goes
    mov   ax,fcount
    dec   ax
    mov   cx,rows
    mov   dx,0
    div   cx
;   ax has the column number and dx has the row
    lea  di,fbox+1
    mov  cl,messwidth ; number of bytes per message
    mul  cl
    add  di,ax
    mov  ax,dx
    mov  cx,colwidth+1
    mul  cx
    add  di,ax
;
    mov  ax,tseg
    push ds
    mov  ds,ax
    mov  cx,9
    cld
rep movsb
    pop  ds
;
fb9:
    pop  si
    add  si,4
    jmp   fb0
fb_end:
    pop  si
; now we have to print the thing
    mov   ax,6
    mul   cwidth
    mov   cury,ax
    lea   dx,fbox
    mov   left_margin,48
    mov   curx,48
    call  prbox
    ret
;
;  ms0 moves the title into tbox
;
ms0:
    lodsb
    cmp   al,0
    je    ms1
    stosb
    jmp   ms0
ms1:
    call present
    lea   dx,tbox
    mov   left_margin,112
    mov   curx,112
    mov   cury,0
    call  prbox
    ret
CSEG ends
     END
