; OKTREE.ASM is the module that fights its way through the maze of the
; tree showing 1-2-3 look and feel menus
;
;  this routine uses the tree information to call almost every
; routine in OPTIKS.
; this is the central procedure, called from main - exitting
; back to main where the do_display is called
;
; the main routine here is:
;      DO_TREE
; also used is GOBACK which pops the tree up a level
;
print macro string
      call blip
      call blop
      call blip
      mov  left_margin,100
      mov  curx,100
      mov  cury,64
      lea  dx,string
      call prbox
      call getkey
      call present
      call goback
      endm
tseg segment public 'DATA'
tseg ends
lseg segment public 'DATA'
        ASSUME DS:LSEG,ES:LSEG
 extrn font0:byte
 extrn font1:byte
lseg ends
dseg  segment public 'DATA'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn  goback1:word,curx:word,cury:word,err1:byte
extrn  helpno:word,save_font:word
extrn  mode:byte,font:word,debug:byte,left_margin:word
extrn  helps:word,mouse_on:byte,quitter:word
extrn  vid_wid:word,interlace:word,vbuffer:word
extrn  splane:byte
goback2 dw 0
click  db 0
       public goback2
;
; =186 =187 =188 =200 =201 =205
line1  db  "OPTIKS is an evolving program. As such",10
       db  "some features have not been installed",10
       db  "yet. You have chosen an item which, as",10
       db  "of this release, is not complete. The",10
       db  "feature will be included as soon as it",10
       db  "is finished. Please refer DOC files",10
       db  "for information on how to receive the",10
       db  "latest release of OPTIKS.",10
       db  "    Thank you for your patience.",10
       db  "     PRESS ANY KEY TO CONTINUE",0

line2  db  "You have chosen a function of OPTIKS",10
       db  "which is available in the ADVANCED",10
       db  "version only. This version is not",10
       db  "released to the bulletin boards.",10
       db  "The FREE version of OPTIKS will",10
       db  "save to formats marked with a '*'.",10
       db  "     PRESS ANY KEY TO CONTINUE",0
mousex dw  0  ; mouse x location
currmen  dw  0

dseg  ends
CSEG2   SEGMENT PARA PUBLIC 'TEXT'
        ASSUME CS:CSEG2
extrn   help:far
cseg2 ends

CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn  printline:near,highlight:near,reset_segs:near,getkey:near
extrn  getkeynm:near,getmouse:near,prbox:near
extrn  quit:near,print_string:near,blip:near,blop:near
extrn  present:near,tprintline:near
extrn  setplane:near,resetplane:near
; jump tables are cs stuff
mouseline proc near
; this prints the mouse line at mousex
;
; a mouse line is 64 pixels long, it is printed on the line above
; the help line.
      push  ax
      push  cx
      push  dx
      push  di
      push  es
; done mouseline
; calculate the line where the mouseline goes
      mov   ax,13
      mov   dx,0
      div   interlace
; ax has has the line to print
      mul   vid_wid  ; current screen wid
      mov   di,ax
      mov   es,vbuffer
; clean the line
      push  ax
      mov   cx,vid_wid
      add   cx,12
      sub   di,8
      cld
     mov  al,0
rep  stosb
      pop   ax
      shl   ax,1
      shl   ax,1
      shl   ax,1
;  calculate where to print the line
      add   ax,mousex
      mov   dx,0
      mov   cx,8
      div   cx
      mov   di,ax
      mov   cx,dx
      mov   al,0ffh
      shr   al,cl
      cld
      stosb
      mov   cx,4
      mov   al,0ffh
rep   stosb
      mov   al,0ffh
      mov   cx,8
      sub   cx,dx
      shl   al,cl
      stosb
      pop   es
      pop   di
      pop   dx
      pop   cx
      pop   ax
      ret
mouseline endp
goback  proc  near
public goback
        call  reset_segs
        mov   sp,goback1
        pop   bp
        pop   si
        ret
goback  endp
gobackf proc  near
public gobackf
        call  reset_segs
        cmp   goback2,0
        jne   go_goback2
        call  quit
go_goback2:
        mov   sp,goback2
        ret
gobackf endp
public do_tree
do_tree proc  near
; on entry to do_tree, the SI register has the ds:offset of the tree
; bp has a valid child - the number of the branch we came from
        call  reset_segs
        push  si
        push  bp
; on entry of do_tree we remember how to exit
        mov   goback1,sp
        call  check_font
;
; print out the BAR on the screen
;
        lodsw
        mov   si,ax
        mov   currmen,ax
        mov   cury,0      ; pixel 1,1
        mov   curx,0
        mov   cx,79       ; length of line
        mov   splane,0eh
        call  setplane
        call  printline   ; prints out the line up to 72 bytes
        call  resetplane
; highlight the current selection
        pop   bp
        pop   si
        push  si
        push  bp
; calculate child to highlight
        mov   bx,bp
        push  bx
        mov   cl,6
        shl   bx,cl
                        ; mult by 64 - 8 bit character * 8 bytes entry
        mov   curx,bx
        mov   mousex,bx
        mov   cury,0
; calculate the si offset
        mov   si,currmen
        mov   ax,bp
        shl   ax,1
        shl   ax,1
        shl   ax,1
        add   si,ax
        mov   cx,7
        mov   splane,09h
        call  printline  ; this is supposed to highlight the 8 bytes
        mov   splane,15
        call  mouseline
        pop   bx
        pop   bp
        pop   si
        push  si
        push  bp
        shl   bx,1 ; multiply by 2
        mov   ax,ds:[si+bx+6] ; check to see if guy exists
        cmp   ax,0
        jne   no0si
        lea   si,err1        ; err1 means there is no such animal
        mov   helpno,256     ; explanation
;       jmp  no0si2
no0si:
        mov   bx,ax
        mov   si,ds:[bx+2]  ; address of line
        push  ds
        mov   ax,tseg
        mov   ds,ax
        lodsb               ; help number from head of line
        pop   ds
; this is where help routine goes
        mov   ax,0
        mov   helpno,ax
; print line message
        mov   splane,0ah
        mov   cx,79
        mov   curx,0
        mov   cury,16
        call  tprintline
        mov   splane,15
        jmp   do_getkey
no0si2:
; print error message
        mov   cx,79
        mov   curx,0
        mov   cury,16
        call  printline
do_getkey:
; this routine does mouse keystokes or key keystrokes
        cmp   mouse_on,1
        jne   no_mouse
; this checks to see if the mouse is ready to move
;char_jump dw exit_tree,do_return,go_left,go_right
        call   getmouse
        cmp   bp,"KG"
        je    no_mouse
; the mouse is on and a left or right has been pressed
        cmp   bx,2  ; left
        jle   proc_key
        cmp  bx,6
        jg    do_getkey
        call  mouseline
        cmp  bx,4
        je   mleft
;mright:
        test  dh,3
;       jz    nmright
;       sub   mousex,2
;mright:
        add   mousex,8
        test  mousex,56
        jz    move_mright
        jmp   do_getkey
move_mright:
        mov   bp,0
        jmp   proc_key
mleft:
;       cmp   mousex,0
;       jle   do_getkey
        test  dh,3
;       jz    nmleft
;       add   mousex,2
;mleft:
        sub   mousex,8
        test  mousex,56
        jz    move_mleft
        jmp   do_getkey

move_mleft:
; moving left
        mov   bp,0
        jmp   proc_key
no_mouse:
        call  getkeynm
        cmp   bp,'KG'
        je    do_getkey
; have a left or right keystroke
proc_key:
        pop   bp
        pop   si
        push  si
        push  bp
        cmp   bx,6
        jg    check_alpha1
        jmp   cs:char_jump[bx]
check_alpha1:
        jmp   check_alpha
do_return:
; this executes the guy on the tree
        mov   bx,bp
        shl   bx,1
        mov   ax,ds:[si+bx+6]
        mov   bp,0
        mov   si,ax
        cmp   si,0
        je    not_installed
        cmp   word ptr ds:[si],1
        je    not_installed
        cmp   word ptr ds:[si],2
        je    not_allowed
        cmp   word ptr ds:[si+4],0
        jne   bypass_call
        cmp   word ptr ds:[si+6],0
        je    not_installed
        cmp   debug,3
        jne   no_debug
        int   3        ; debug break
no_debug:
        lea   ax,bypass_do
        push  ax
        mov   goback2,sp  ; save the way out
        call  word ptr ds:[si+6]
        pop   ax
        jnc  bypass_do
        cmp  dx,'KG'
        je    not_allowed
        jmp  bypass_do
bypass_call:
        call  do_tree
        jmp   bypass_do
not_installed:
        print line1
not_allowed:
        print line2
bypass_do:
       call  reset_segs
       mov   ax,quitter
       mov   goback2,ax
       pop    bp
       pop    si
       jmp    do_tree
go_left:
       pop    bp
       pop    si
       dec    bp
       cmp    bp,0
       jge    ok_left
       mov    bp,ds:[si]+4
       dec    bp
ok_left:
       jmp    do_tree
go_right:
       pop    bp
       pop    si
       inc    bp
       cmp    bp,ds:[si]+4
       jl     ok_right
       mov    bp,0
ok_right:
       jmp    do_tree
check_alpha:
; here we have an alpha character so we must try and match it
; with one of the menu thingies
      cmp     al,0
      jne    not_function
; check for help
      cmp    ah,3bh
      jne    no_help
      mov    helps,2
      call   help
        call  reset_segs
        call  check_font
       pop    bp
       pop    si
       push   si
       push   bp
        lodsw
        mov   si,ax
        mov   cury,0      ; pixel 1,1
        mov   curx,0
        mov   cx,79       ; length of line
        mov   splane,0eh
        call  setplane
        call  printline   ; prints out the line up to 72 bytes
        call  resetplane
       pop    bp
       pop    si
       jmp    do_tree
no_help:
      cmp    ah,68
      jne    not_function
      call   quit
not_function:
       cmp    al,'0'
       jl     no_alpha
       cmp    al,'9'
       jg     no_number
       jmp    got_upper
no_number:
       cmp    al,"A"
       jl     no_alpha
       cmp    al,"z"
       jg     no_alpha
       cmp    al,"Z"
       jle    got_upper
       cmp    al,'a'
       jl     no_alpha
       sub    al,32
got_upper:
        pop   bp
        pop   si
        push  si
        push  bp
        mov   di,ds:[si] ; get address of bar
        mov   cx,ds:[si+4] ; get count of bar
        cmp    di,0
        je     no_alpha_1
        cmp    cx,0
        je     no_alpha_1
        mov    bx,0
get_alpha_loop:
        cmp    byte ptr ds:[di],al
        je     got_alpha_byte
        add     di,8
        inc    bx
        loop   get_alpha_loop
        jmp    no_alpha_1
got_alpha_byte:
; al still has the letter of the entry
; bx has the number of the thing to do
        pop   bp
        pop   si
        mov   bp,bx
        push  si
        push  bp
        jmp   do_return
no_alpha_1:
        pop   bp
        pop   si
        push  si
        push  bp
no_alpha:
       jmp    do_getkey
exit_tree:
        pop   bp
        pop   si
        call  reset_segs
        mov   ax,save_font
        mov   font,ax
        ret
say_not_installed:
; tell em thanks but no thanks
        lea   si,err1
        mov   cx,72
        mov   curx,0
        mov   cury,40
        call  printline
        call  getkey
;       call  present
        ret
check_font:
public check_font
; get the current font and save it
        cmp   mode,6
        jg    big_font
        assume ds:lseg
        lea   ax,ds:font1
        assume ds:dseg
        mov   font,ax
        ret
big_font:
        assume ds:lseg
        lea   ax,ds:font0
        assume ds:dseg
        mov   font,ax
        ret
char_jump dw exit_tree,do_return,go_left,go_right
do_tree endp
CSEG    ENDS
        END
