; OKVIRT.ASM is the virtual page management system of OPTIKS
; for non-virtual pages is merely sets up the p_segs
;
; this hase the routines
;    ERASE_MEM
;    XOR_MEM
;    EMS_ALLOCATE
;    EMS_DEALLOC
;    GET_CURR, GET_NEXT, and GET_PREV_SEGMENT
;    GET_CURR2, GET_NEXT2, and GET_PREV2_SEGMENT
;    ems allocations
;
virt struc
v_seg  dw  0
v_type db  0
virt  ends

virt_size equ 3

segmentsize equ 8000h
dseg segment public 'DATA'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn   curr_seg:word
extrn   work_seg:word,work2_seg:word
extrn   ems_handle:word,ems_frame:word,ems_allocated:word,ems_count:word
extrn   vwid:word,maxlines:word,ems_free:word,ems_name:byte
;
;   an array at seg1 has the offsets of the real memory
;   ems_frame and ems_frame+800h is used for ems memory
;
virt_mem db 5*105 dup(0)   ; 100 pages max
;
;
xms_mem   dw  0  ; who much XMS we are allocating
dos_mem  dw  0  ; how much real memory we are using
ems_mem  dw  0  ; total ems memory pages (in 32k chunks)
tot_mem  dw  0  ; use instead of maxmem?
public xms_mem,dos_mem,ems_mem,tot_mem
savedi   dw  0

ems_flip   db 0
xms_flip   db 0

ems_page_1  dw -1
ems_page_2  dw -1

xms_page_1  dw -1     ; page last used in frame 1
xms_page_2  dw -1     ; page last used in frame 2

xms_frame_1 dw  0     ; segments fo xms memory
xms_frame_2 dw  0

xms_switch  db 0

xmscontrol  dd 0
xms_allocated dw 0
xms_handle    dw 0


xmsblock equ this byte
	xLength		dw	0,0	; 32-bit number of bytes to transfer
	SourceHandle	dw	0	; Handle of source block
	SourceOffset	dw	0,0	; 32-bit offset into source
	DestHandle	dw	0	; Handle of destination block
	DestOffset	dw	0,0	; 32-bit offset into destination block
;
dseg ends
;
;
;
;
CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
public  erase_mem,get_curr_seg,get_next_seg
public  get_curr2_seg,get_next2_seg,get_prev2_seg
public do_erase_mem,get_prev_seg,do_erase_memg
public ems_dealloc
;
extrn   reset_segs:near,present:near
extrn   quit:near,goback:near,reset_segs_far:far
extrn   blip_far:far,blop_far:far
mem_alloc:
public mem_alloc
   call  far ptr mem_alloc_far
   ret
ems_allocate:
public ems_allocate
   call  far ptr ems_allocate_far
   ret
CSEG  ENDS

;
CSEG2   SEGMENT PARA PUBLIC 'TEXT'
        ASSUME CS:CSEG2,DS:DSEG,ES:DSEG
mem_alloc_far proc far
; this routine allocates memory off all types
; first real memory
            mov   tot_mem,0
            mov   ems_mem,0
            mov   dos_mem,0
            mov   xms_mem,0
            mov   DI,offset virt_mem
            CLD
            MOV   CX,32
get_mem_loop:
            PUSH  CX
            MOV   AH,48h
            MOV   BX,segmentsize/16
            push  di
            INT   21h
            pop   di
            jnc   good_get1
            POP   CX
            JMP   finish_mem
good_get1:
            CMP   BX,segmentsize/16
            JE    goodget
            POP   CX
            JMP   finish_mem
goodget:
            cld
            mov   [di].v_seg,ax
            mov   [di].v_type,'d'
            add   di,virt_size
            POP   CX
            inc   dos_mem
            inc   tot_mem
            LOOP  get_mem_loop
finish_mem:
            CMP   tot_mem,3
            jge   good_mem1
memory_error:
            stc
            ret
good_mem1:
; check out XMS memory
            mov   savedi,di
        push    di
	; Is an XMS driver installed?
        mov     xms_switch,0
	mov	ax,4300h
	int	2Fh	 
	cmp	al,80h	
	jne	NoXMSDriver
	; Get the address of the driver's control function
	mov	ax,4310h
	int	2Fh
	mov	word ptr [XMSControl],bx	; XMSControl is a DWORD
	mov	word ptr [XMSControl+2],es
	
	; Get the XMS driver's version number
	mov	ah,00h
	call	[XMSControl]	; Get XMS Version Number
        ; we don't do anything with it, this is for debug only
;
; get the biggest block (remember XMS is slower than EMS)
; so we are not allocating it now

	; get the largest block of extended memory available
	mov	ah,8
	call	[XMSControl]
	; ax returns the largest block
	; dx returns the free memory in k bytes
        mov     cx,32    ; 32k block size
        mov     dx,0
        div     cx
        cmp     ax,2
        jb      noXMSDriver
        mov     xms_switch,1   ; we got it
        pop     di
        sub     di,virt_size   ; back off to previus
        mov     ax,[di].v_seg
        mov     [di].v_type,0
        mov     xms_frame_1,ax
	
        sub     di,virt_size   ; back off to previus
        mov     ax,[di].v_seg
        mov     [di].v_type,0
        mov     xms_frame_2,ax
	sub     dos_mem,2
        sub     tot_mem,2
            mov   savedi,di
        call    blip_far
        call    blop_far
        push  di
noXMSdriver:
        pop   di
; check out EMS memory
            call reset_segs_far
            lea  dx,ems_name
            mov  ax,3d00h
            int  21h ; open the ems handle
            jc   no_ems
            mov  bx,ax  ; ems handle
            mov  ems_handle,ax
            mov   ax,4400h
            mov   dx,0
            int   21h   ; ioctl
            jnc   got_ems
close_ems:
            mov   ah,3eh
            mov   bx,ems_handle
            int   21h
            mov   ems_handle,0
            jmp   no_ems
got_ems:
            test  dl,80h
            jz    close_ems
            mov   ax,4407h
            mov   dx,0
            int   21h   ; output status
            jc    close_ems
            or    al,al  ;ready
            jz    close_ems
; its our guy close him
            mov   ah,3eh
            mov   bx,ems_handle
            int   21h
            mov   ems_handle,0
; now get the ems stuff
            mov   ah,40h
            int   67h  ; check if working
            or    ah,ah
            jnz   no_ems
; get page frame segment
            mov   ah,41h
            int   67h
            or    ah,ah
            jnz   no_ems
;  got page frame
            mov   ems_frame,bx
; get the ems free pages
            mov   ah,42h
            int   67h
            or    ah,ah
            jnz   no_ems
            mov   ems_free,bx
            cmp   ems_count,0
            jne   fixed_ems
            mov   ax,bx
            and   ax,11111100b ; make it divisable by 4
            mov   cx,16
            mul  cx
            mov   ems_count,ax
fixed_ems:
            mov   savedi,di
            call  far ptr ems_allocate_far
no_ems:
; calculate maxlines, total number of lines in pic
            cmp   xms_switch,1
            jne   no_xms
            call  far ptr xms_allocate_far
no_xms:
            call  reset_segs_far
; calculate new maxlines
            MOV   AX,segmentsize
            mov   cx,tot_mem
            mul   cx
            div   vwid
            mov   maxlines,ax
     clc
     ret

mem_alloc_far  endp
;
xms_allocate_far  proc  far

	; allocate the block so we can use it
	; get the largest block of extended memory available
	mov	ah,8
	call	[XMSControl]
	; ax returns the largest block
	; dx returns the free memory in k bytes
        mov     cx,32    ; 32k block size
        mov     dx,0
        div     cx
; ax has the number of 32k blocks
        cmp     ax,3
        jb      bad_xms
        mov     bp,ax
       add   ax,tot_mem
       cmp   ax,100     ; mem_max
       jl    good_xms_cnt
       mov   ax,100
       sub   ax,tot_mem
       mov   bp,ax
good_xms_cnt:
       mov   ax,bp
       mov   cx,32
       mul   cx
       mov   xms_allocated,ax
	mov	dx,ax  ; size in K
	mov	ah,9
	call	[XMSControl]
	; ax = 1 if allocated, dx has the handle to the block
        mov     xms_handle,dx
        cmp     ax,1
        jne     bad_xms
; got the memory
; set up the loop to do it
        mov   di,savedi
        mov   ax,xms_allocated
        mov   cx,32
        mov   dx,0
        div   cx
        mov   cx,ax
        mov   dx,0
xms_setup_loop:
        mov   [di].v_seg,dx
        mov   [di].v_type,'x'
        inc   dx
        add   di,virt_size
            inc   xms_mem
            inc   tot_mem
        loop  xms_setup_loop
        mov   savedi,di
        mov  ax,tot_mem
        mov  cx,segmentsize
        mul  cx
        div  vwid
        add  maxlines,ax
	
bad_xms:
;
        clc
        ret
xms_allocate_far endp
;
ems_allocate_far  proc  far
; this allocates the number of segments indicated by ems_count
; and puts the results in ems_allocated
        call  reset_segs_far
        mov  ax,ems_count
        cmp  ax,0
        jg   cont_alloc1
        stc
        ret
cont_alloc1:
        mov  cl,4
        shr  ax,cl
        cmp  ax,0
        jg   cont_alloc
leave_alloc:
        stc
        ret
cont_alloc:
; ax has the number of 16k pages to allocate
        mov  bp,ax
; check to see if we beat out 100
       shr   ax,1
       add   ax,dos_mem
       cmp   ax,100     ; mem_max
       jl    good_ems_cnt
       mov   ax,100
       sub   ax,dos_mem
       shl   ax,1
       mov   bp,ax
good_ems_cnt:
; get the unallocated count to determine if we can go on
        mov  ah,42h
        push  bp
        int  67h
        pop   bp
        or   ah,ah
        jnz  leave_alloc
        mov  ems_free,bx
        cmp  bx,bp
        jl   leave_alloc
; allocate the count of pages
        mov  ah,43h
        mov  bx,bp
        push  bp
        int  67h
        pop  bp
        or   ah,ah
        jnz  leave_alloc
        mov  ems_handle,dx  ; now we are using the handle for EMS
        mov  ems_allocated,bp
        sub  ems_free,bp
; success, fill up the array with the data
;  ems_allocated has the total count of 16k pages allocated

        mov   cx,bp
        shr   cx,1    ; convert to 32k segs
        mov   di,savedi
        mov   dx,0
ems_setup_loop:
        mov   [di].v_seg,dx
        mov   [di].v_type,'e'
        inc   dx
        inc   dx
        add   di,virt_size
            inc   ems_mem
            inc   tot_mem
        loop  ems_setup_loop
        mov   savedi,di
; done
        mov  ax,tot_mem
        mov  cx,segmentsize
        mul  cx
        div  vwid
        add  maxlines,ax

;
        clc
        ret
ems_allocate_far endp
CSEG2 ENDS
;
CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:DSEG,ES:DSEG
ems_dealloc   proc  near
; deallocates the pages associated with the handle
        call reset_segs
        mov  ax,ems_allocated
        cmp  ax,0
        jg   cont_dealloc
        jmp  xms_dealloc
cont_dealloc:
        mov   ah,45h
        mov   dx,ems_handle
        int    67h
        mov  bp,ems_allocated
        mov   ems_allocated,0
        add  ems_free,bp
        mov   curr_seg,0
        mov   ax,ems_mem
        sub   tot_mem,ax
        mov   ems_mem,0
        ret
xms_dealloc:
        cmp   xms_mem,0
        jne   cont_dealloc2
        ret
cont_dealloc2:

	; free the block
	mov	ah,10
	mov	dx,xms_handle
	call	[XMSControl]
        mov   curr_seg,0
        mov   ax,xms_mem
        sub   tot_mem,ax
        mov    xms_mem,0
        ret

ems_dealloc   endp
;
;
;
;
;
get_curr_seg  proc  near
; this takes work_seg (ordinal segment) and returns a seg in ax
        push  bx
        push  cx
        push  dx
        push  si
        push  di
        push  bp
        push  ds
        mov   ax,dseg
        mov   ds,ax
        mov   bx,work_seg
        cmp   bx,0
        jl    real_bad_seg
        cmp   tot_mem,bx
        jg    good_seg
real_bad_seg:
; move the last segment into bx
        mov    bx,tot_mem
        dec    bx
good_seg:
; multiply by virt_size
        push  cx
        push  dx
        mov   cx,virt_size
        mov   ax,bx
        mul   cx
; now the allocation
        mov   bx,ax
        call  page_in
        pop   dx
        pop   cx
        pop   ds
        pop   bp
        pop   di
        pop   si
        pop   dx
        pop   cx
        pop   bx
        ret
get_curr_seg  endp
;
page_in proc  near
; this routine pages in ems or xms memory as needed
        push  bx
        mov   al,virt_mem[bx].v_type
        cmp   al,'d'
        je    page_in_dos
        cmp   al,'e'
        je    page_in_ems
        cmp   al,'x'
        je    page_in_xms
page_in_dos:
        pop   bx
        mov   ax,virt_mem[bx].v_seg
        ret
page_in_ems:
        mov   dx,virt_mem[bx].v_seg
        cmp   ems_page_1,dx
        je    done_ems_1
        cmp   ems_page_2,dx
        je    done_ems_2
; now do the flip
        cmp   ems_flip,0
        je    pagein_ems_1
        mov   cx,2
        mov   bx,dx
        call  ems_pagein
        jmp   done_ems_2
pagein_ems_1:
        mov   cx,0
        mov   bx,dx
        call  ems_pagein
        jmp   done_ems_1
done_ems_1:
        pop   bx
        mov   ax,virt_mem[bx].v_seg
        mov   ems_page_1,ax
        mov   ax,ems_frame
        mov   ems_flip,1
        ret
done_ems_2:
        pop   bx
        mov   ax,virt_mem[bx].v_seg
        mov   ems_page_2,ax
        mov   ax,ems_frame
        add   ax,800h
        mov   ems_flip,0
        ret
page_in_xms:
        mov   dx,virt_mem[bx].v_seg
        cmp   xms_page_1,dx
        je    done_xms_1
        cmp   xms_page_2,dx
        je    done_xms_2
; now do the flip
        cmp   xms_flip,0
        je    pagein_xms_1
        mov   dx,xms_page_2
        mov   bp,xms_frame_2
        call  xms_pageout
        mov   dx,xms_page_2
        mov   bp,xms_frame_2
        call  xms_pagein
        jmp   done_xms_2
pagein_xms_1:
        mov   dx,xms_page_1
        mov   bp,xms_frame_1
        call  xms_pageout
        mov   dx,xms_page_1
        mov   bp,xms_frame_1
        call  xms_pagein
        jmp   done_xms_1
done_xms_1:
        pop   bx
        mov   ax,virt_mem[bx].v_seg
        mov   xms_page_1,ax
        mov   ax,xms_frame_1
        mov   xms_flip,1
        ret
done_xms_2:
        pop   bx
        mov   ax,virt_mem[bx].v_seg
        mov   xms_page_2,ax
        mov   ax,xms_frame_2
        mov   xms_flip,0
        ret
xms_pageout:
; dx has the last_page
; bp has the frame
        cmp   dx,-1
        jne   cont_po
        ret
cont_po:
        push  bx
        mov   xlength,segmentsize
        mov   xlength+2,0
        mov   ax,xms_handle
        mov   desthandle,ax
        mov   sourceoffset,0
        mov   sourceoffset+2,bp
        mov   sourcehandle,0
        mov   ax,dx  ; old page
        mov   cx,segmentsize
        mul  cx
        mov   destoffset,ax
        mov   destoffset+2,dx
	; page in the memory block
	mov	ah,11
	mov	si,offset xmsblock
	call	[XMSControl]
	; ax=1 if ok
        pop   bx
        ret
xms_pagein:
; setup move
        push  bx
        mov   xlength,segmentsize
        mov   xlength+2,0
        mov   ax,xms_handle
        mov   sourcehandle,ax
        mov   ax,virt_mem[bx].v_seg
        mov   cx,segmentsize
        mul  cx
        mov   sourceoffset,ax
        mov   sourceoffset+2,dx
        mov   word ptr destoffset,0
        mov   destoffset+2,bp
        mov   desthandle,0
	; page in the memory block
	mov	ah,11
	mov	si,offset xmsblock
	call	[XMSControl]
	; ax=1 if ok
        pop   bx
        ret
ems_pagein:
        push  bx
        push  cx
        mov   ah,44h  ; bx has the page
        mov   al,cl   ; which of the 4 pages to move it into
        mov   dx,ems_handle
        int   67h
        pop   cx
        pop   bx
        mov   ah,44h  ; bx has the page
        mov   al,cl   ; which of the 4 pages to move it into
        inc   al
        inc   bx
        mov   dx,ems_handle
        int   67h
        ret
page_in  endp
;
;
get_next_seg  proc  near
        push  bx
        push  ds
        mov   ax,dseg
        mov   ds,ax
        inc   work_seg
        call  get_curr_seg
        pop   ds
        pop   bx
        ret
get_next_seg  endp
;
get_prev_seg  proc  near
        push  bx
        push  ds
        mov   ax,dseg
        mov   ds,ax
        dec   work_seg
        call  get_curr_seg
        pop   ds
        pop   bx
        ret
get_prev_seg  endp
;
;
;
;
;
;
get_curr2_seg  proc  near
; this is the same except it uses work2_seg
        push  bx
        push  cx
        push  dx
        push  si
        push  di
        push  bp
        push  ds
        mov   ax,dseg
        mov   ds,ax
        mov   bx,work2_seg
        cmp   bx,0
        jl    real_bad_seg2
        cmp   tot_mem,bx
        jg    good_seg2
real_bad_seg2:
; move the last segment into bx
        mov    bx,tot_mem
        dec    bx
good_seg2:
; multiply by virt_size
        push  cx
        push  dx
        mov   cx,virt_size
        mov   ax,bx
        mul   cx
; now the allocation
        mov   bx,ax
        call  page_in
        pop   dx
        pop   cx
        pop   ds
        pop   bp
        pop   di
        pop   si
        pop   dx
        pop   cx
        pop   bx
        ret
get_curr2_seg  endp
;
;
;
get_next2_seg  proc  near
        push  bx
        push  ds
        mov   ax,dseg
        mov   ds,ax
        inc   work2_seg
        call  get_curr2_seg
        pop   ds
        pop   bx
        ret
get_next2_seg  endp
;
get_prev2_seg  proc  near
        push  bx
        push  ds
        mov   ax,dseg
        mov   ds,ax
        dec   work2_seg
        call  get_curr2_seg
        pop   ds
        pop   bx
        ret
get_prev2_seg  endp
;
;
;
;
;
;
;
do_erase_mem proc  near
; same as erase_mem with a present
      call  erase_mem
      call  present
      ret
do_erase_mem endp
do_erase_memg proc  near
      call  erase_mem
      call  present
      call  goback
      ret
do_erase_memg endp
erase_rmem  proc  near
         call reset_segs
         mov   cx,dos_mem
       jmp    do_clear
erase_mem:
public erase_rmem
public erase_mem
; only erases all memmory
         call reset_segs
         mov   cx,tot_mem
do_clear:
         mov  work_seg,0
         cld
clear_rmem_loop:
         push  cx
         call  get_curr_seg
         mov  es,ax
         mov  cx,segmentsize/2
         mov  di,0
         mov   ax,0
         cld
rep      stosw
         inc   work_seg
         pop   cx
         loop  clear_rmem_loop
         mov  work_seg,0
         mov  work2_seg,0
; put a test pattern into the last seg
            call  reset_segs
            mov   work_seg,20
            call  get_curr_seg
            mov   work_seg,21
            call  get_curr_seg
         mov   bx,tot_mem
            dec   bx
            mov   work_seg,bx
            call  get_curr_seg
            mov   es,ax
            mov   di,7000h
            mov   cx,40h
            mov   ax,0f0fh
e_loop0:
            push  cx
            push  ax
            mov   cx,2
            mov   ax,0fffh
            cld
rep         stosw
            pop   ax
            mov   cx,1eh
            cld
rep         stosw
            clc
            rcr   ax,1
            jnc   e_bot_loop
            or    ax,8000h
e_bot_loop:
            pop   cx
            loop  e_loop0
            call  reset_segs
            mov  work_seg,0
            call  get_curr_seg
;
         ret
      ret
erase_rmem endp
CSEG    ENDS
        END
	; allocate the block so we can use it

	mov	dx,size in K
	mov	ah,8
	call	[XMSControl]
	; ax = 1 if allocated, dx has the handle to the block
	
	; page in the memoru block
	mov	ah,10
	mov	si,offset xmsblock
	call	[XMSControl]
	; ax=1 if ok

; if source handle is 0 then the sorce offset is real memory
; ditto for desthandle
; otherwise the offsets are long offsets into the block
	
		
		
